#include <Wire.h>
  
/*
  Blink
  Turns on an LED on for one second, then off for one second, repeatedly.
 
  This example code is in the public domain.
 */
 
// Pin 13 has an LED connected on most Arduino boards.
// give it a name:
//int led = 13;
int led = 20;
const int GyroA=0x68;  // I2C address of the MPU-6050

float AcX,AcY,AcZ,Temp,GyX,GyY,GyZ;
// pwm for motors
int pwm8 = 8;
int pwm9 = 9;

// left
int m1_a = 4;
int m1_b = 5;
// right
int m2_a = 6;
int m2_b = 7;
// motor "0" offset
unsigned char m1Offset= 0;
unsigned char m2Offset= 0;


float kp= 30;
float ki= 4;
float kd= 0;

float kpS= 0;
float kiS= 0;
float kdS= 0;

float target= -0.95;

void readGyro(){
  
        Wire.beginTransmission(GyroA);
  Wire.write(0x3B);  // starting with register 0x3B (MPU6050_ACCEL_XOUT_H)
  Wire.endTransmission(false);
  Wire.requestFrom(GyroA,14,true);  // read a total of 14 registers
  AcX=Wire.read()*256+Wire.read();  // 0x3B (MPU6050_ACCEL_XOUT_H) & 0x3C (MPU6050_ACCEL_XOUT_L)    
  AcY=Wire.read()*256+Wire.read();  // 0x3D (MPU6050_ACCEL_YOUT_H) & 0x3E (MPU6050_ACCEL_YOUT_L)
  AcZ=Wire.read()*256+Wire.read();  // 0x3F (MPU6050_ACCEL_ZOUT_H) & 0x40 (MPU6050_ACCEL_ZOUT_L)
  Temp=(Wire.read()*256+Wire.read())/340.00+36.53;  // 0x41 (MPU6050_TEMP_OUT_H) & 0x42 (MPU6050_TEMP_OUT_L)
  GyX=Wire.read()*256+Wire.read();  // 0x43 (MPU6050_GYRO_XOUT_H) & 0x44 (MPU6050_GYRO_XOUT_L)
  GyY=Wire.read()*256+Wire.read();  // 0x45 (MPU6050_GYRO_YOUT_H) & 0x46 (MPU6050_GYRO_YOUT_L)
  GyZ=Wire.read()*256+Wire.read();  // 0x47 (MPU6050_GYRO_ZOUT_H) & 0x48 (MPU6050_GYRO_ZOUT_L)

}

#define ACCELEROMETER_SENSITIVITY 8192.0
#define GYROSCOPE_SENSITIVITY 65.536
 
#define M_PI 3.14159265359          
 
#define dt 0.003                                                        // 10 ms sample rate!    
 
void ComplementaryFilter(int accData[3], int gyrData[3], float *yaw, float *pitch, float *speed)
{
    float pitchAcc, yawAcc;               
 
  
        // Integrate accel
        *speed += (float) accData[0]/ACCELEROMETER_SENSITIVITY* dt;
  
    // Integrate the gyroscope data -> int(angularSpeed) = angle
    *yaw += ((float)gyrData[2] / GYROSCOPE_SENSITIVITY) * dt; // Angle around the Z-axis
    *pitch -= ((float)gyrData[1] / GYROSCOPE_SENSITIVITY) * dt;    // Angle around the Y-axis
 
    // Compensate for drift with accelerometer data if !bullshit
    // Sensitivity = -2 to 2 G at 16Bit -> 2G = 32768 && 0.5G = 8192
    int forceMagnitudeApprox = abs(accData[0]) + abs(accData[1]) + abs(accData[2]);
    if (forceMagnitudeApprox > 8192 && forceMagnitudeApprox < 32768)
    {
        // Turning around the Z axis results in a vector on the Y-axis
        //yawAcc = atan2f((float)accData[1], (float)accData[2]) * 180 / M_PI;
        //*yaw = *yaw * 0.98 + yawAcc * 0.02;
 
        // Turning around the Y axis results in a vector on the X-axis
        pitchAcc = atan2f((float)accData[0], (float)accData[2]) * 180 / M_PI;
        *pitch = *pitch * 0.90 + pitchAcc * 0.10;
    }
} 

#define FWD 1
#define RWD -1

void initWheels(){


  TCCR1B = TCCR1B & 0b11111000 | 0x02;
  TCCR2B = TCCR2B & 0b11111000 | 0x02;

  
  pinMode(pwm8, OUTPUT);     
  pinMode(pwm9, OUTPUT);    

  pinMode(m1_a, OUTPUT);    
  pinMode(m1_b, OUTPUT);    
  
  pinMode(m2_a, OUTPUT);    
  pinMode(m2_b, OUTPUT);    


  analogWrite(pwm8, 0);
  analogWrite(pwm9, 0);

  digitalWrite(m1_a, LOW);
  digitalWrite(m1_b, HIGH);
  
  digitalWrite(m2_a, LOW);
  digitalWrite(m2_b, HIGH);
  
  
}


void leftWheel( char dir, unsigned char pwm ){
        
  int iPwm;
  
  if (dir == FWD){

        digitalWrite(m1_b, LOW);
        digitalWrite(m1_a, HIGH);
    
  } else if (dir == RWD) {
        digitalWrite(m1_a, LOW);
        digitalWrite(m1_b, HIGH);

  } else {
        return; 
  }
  
  iPwm= pwm+ m1Offset;
  if (iPwm>255){
    iPwm= 255;
  }
  pwm= iPwm;
  
        analogWrite(pwm8, pwm);  
  
}

void rightWheel( char dir, unsigned char pwm ){

  int iPwm;
  
  if (dir == FWD){
    
        digitalWrite(m2_b, LOW);  
        digitalWrite(m2_a, HIGH);

  } else if (dir == RWD) {

        digitalWrite(m2_a, LOW);
        digitalWrite(m2_b, HIGH);

  } else {
        return; 
  }

  
  iPwm= pwm+ m2Offset;
  if (iPwm>255){
    iPwm= 255;
  }
  pwm= iPwm;
  
  analogWrite(pwm9, pwm+ m2Offset);  
  
}

  
void execute( char * array[], unsigned char size ){

  static char i=0;
  char k;
  char buf[50];
  float fValue;
  unsigned char uValue;
  

  if (size == 0){
    return;
  }
  if (size > 10){
    return;
  }
  Serial1.println("cmd");

  for (k=0;k<size; k++){
    sprintf( buf, "%d: %s", k, array[k] );

    Serial1.println( buf );    

  }

  Serial1.println("done");

  //
  if (strcmp("p", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                kp= fValue;
    return;
  }

  if (strcmp("i", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                ki= fValue;
    return;
  }

  if (strcmp("d", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                kd= fValue;
    return;
  }

  // strong
  if (strcmp("ps", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                kpS= fValue;
    return;
  }

  if (strcmp("is", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                kiS= fValue;
    return;
  }

  if (strcmp("ds", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                kdS= fValue;
    return;
  }
  
  if (strcmp("t", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                target= fValue;
    return;
  }
  
  if (strcmp("m1", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                m1Offset= fValue;
    return;
  }

  if (strcmp("m2", array[0] ) == 0){
    fValue = strtod( array[1], 0 );
                m2Offset= fValue;
    return;
  }
    
  
} 

void receiveCommand(){

  const int MAX_BUF=30;
  char incomingByte;
  static char buf[MAX_BUF];
  static char bufIdx=0;
  char i;
  char value;
  char * array[10];
  char size=0;
  char * pItem;

  // send data only when you receive data:
  if (Serial1.available() > 0) {

    // read the incoming byte:
    incomingByte = Serial1.read();
    
    if (incomingByte == 0x0A){


      // add space termination
      buf[bufIdx++]=0x20;

      pItem = &buf[0];
      for (i=0;i<bufIdx;i++){
        if (buf[i] == 0x20){
           buf[i]= 0x0;
          array[size++]= pItem;
          pItem= &buf[i+1];
        }

      }

      // evaluate buffer
      execute( array, size );

      // reset index
      bufIdx=0;
    } else {
      // put data into buffer
      if (bufIdx >= MAX_BUF){
        bufIdx=0;
      }

      buf[bufIdx++] = incomingByte;
    }

    // say what you got:
    // Serial1.write(incomingByte);

  }
}


// 
void blink(){

  static char i=0;

  // invert i
  i= 1-i;
  
  // switch LED depending on i
  if (i){
          digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
  } else {
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
  }
  
  
}


// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);     
  
  //
  initWheels();

  //
  Wire.begin();
  Wire.beginTransmission(GyroA);
  Wire.write(0x6B);  // MPU6050_PWR_MGMT_1 register
  Wire.write(0);     // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);
  

  // opens serial port, sets data rate to 115200 bps
  Serial1.begin(115200);
        
  Serial1.println("---");
  Serial1.println("start ");
  
}

float calcPID( float e ){
  
  #define IMAX 255
  #define IMIN -255
  
  float P;
  static float I= 0; 
  float D;
  static float eLast= 0;
  float v;
  
  P= kp*e;
  I= ki*e + I;
  D= kd* ( e - eLast );
  eLast= e;
  
  if (I > IMAX){
    I= IMAX;
  }
  if (I < IMIN){
    I= IMIN;
  }
  
  v= P + I + D;
  
  return v;
}


float calcPIDStrong( float e ){
  
  #define IMAX 500
  #define IMIN -500
  
  float P;
  static float I= 0; 
  float D;
  static float eLast= 0;
  float v;
  
  P= e;
  I= e + I;
  D= e - eLast;
  eLast= e;
  
  if (I > IMAX){
    I= IMAX;
  }
  if (I < IMIN){
    I= IMIN;
  }
  
  v= kpS* P + kiS*I + kdS*D;
  
  return v;
}

// the loop routine runs over and over again forever:
void loop() {

  // time vars
  static char t=0;
  static char s=0;
  
  // loop time
  static long lastTimeStamp=0;
  static long currentTimeStamp=0;
  int timeDiff;
  
  // 
  static float pitch=0;
  static float yaw=0;
  static float speed=0;
  
  static float fAcc[3]= {0, 0, 0};
  static float fGyr[3]= {0, 0, 0};
  
  int acc[3];
  int gyr[3];
  
  
  // control
  float fDiff;
  unsigned char pwm;
  int diff;
        
  
  currentTimeStamp= millis();
  timeDiff= currentTimeStamp- lastTimeStamp;
    
  // calc gyro 
  if (timeDiff>=3){
          lastTimeStamp= currentTimeStamp;
    
        readGyro();

    acc[0]= AcX;
    acc[1]= AcY;
    acc[2]= AcZ;

    gyr[0]= GyX;
    gyr[1]= GyY;
    gyr[2]= GyZ;

    
    ComplementaryFilter( acc, gyr, &yaw, &pitch, &speed );
    
    // control loop
    fDiff= pitch-target;

    if (abs(fDiff) < 20){
        fDiff= calcPID( fDiff );
    } else {
        fDiff= calcPIDStrong( fDiff );
    }

    diff= fDiff;

    if (diff > 255){
      diff=255;
    }
    if (diff < -255){
      diff=-255;
    }

    pwm= abs(diff);
    

    if (diff > 0){
      leftWheel( -1, pwm );
      rightWheel( 1, pwm);
    } else {
      leftWheel( 1, pwm );
      rightWheel( -1, pwm);
    }    


          s++;
    if (s==10){
      // ... blink
      blink();

      s=0;
      receiveCommand();

      Serial1.print("::");
      Serial1.print(timeDiff);
      Serial1.print(" ");    
      Serial1.print(pwm);
      Serial1.print(" ");    
      Serial1.print( pitch );
      Serial1.print(" ");
      Serial1.println( speed );

    }

  
  }
  
  
  
}



 
